<template>
  <v-row class="ma-0">
    <v-col cols="12">
      <v-pagination
        v-if="pagination.lastPage > 1"
        class="d-inline-block"
        v-model="pagination.currentPage"
        :length="pagination.lastPage"
        :total-visible="10"
        @input="changePage"
      ></v-pagination>
      <span class="float-right"
        >Hiển thị từ {{ pagination.from }} ~ {{ pagination.to }} trong tổng số
        {{ pagination.total }} user</span
      >
    </v-col>
    <v-col cols="12">
      <v-simple-table fixed-header height="700px">
        <template v-slot:default>
          <thead>
            <tr>
              <th class="text-center">#</th>
              <th class="text-left">Họ tên</th>
              <th class="text-left">Email</th>
              <th class="text-left">Nhóm</th>
              <th class="text-left">Trạng Thái</th>
              <th></th>
            </tr>
          </thead>
          <tbody>
            <template v-if="items.length > 0">
              <tr v-for="(item, index) in items" :key="item.id">
                <td class="text-center">{{ index + 1 }}</td>
                <td>{{ item.name }}</td>
                <td>{{ item.email }}</td>
                <td>{{ item.groupRole }}</td>
                <td>
                  <span v-if="item.isActive" class="green--text"
                    >Đang hoạt động</span
                  >
                  <span v-else class="red--text">Tạm khóa</span>
                </td>
                <td class="text-center">
                  <v-btn icon @click="onEdit(item.id)">
                    <v-icon class="light-blue--text">mdi-pencil</v-icon>
                  </v-btn>
                  <v-btn icon @click="onDelete(item.id, item.name)">
                    <v-icon class="red--text">mdi-trash-can-outline</v-icon>
                  </v-btn>
                  <v-btn
                    icon
                    @click="onUpdateStatus(item.id, item.name, item.isActive)"
                  >
                    <v-icon v-if="item.isActive">mdi-account-lock</v-icon>
                    <v-icon v-else>mdi-account-lock-open</v-icon>
                  </v-btn>
                </td>
              </tr>
            </template>
            <template v-else>
              <tr>
                <td colspan="6" class="text-center">Không có dữ liệu</td>
              </tr>
            </template>
          </tbody>
        </template>
      </v-simple-table>
    </v-col>
    <v-col cols="12">
      <v-pagination
        v-if="pagination.lastPage > 1"
        class="d-inline-block"
        v-model="pagination.currentPage"
        :length="pagination.lastPage"
        :total-visible="10"
        @input="changePage"
      ></v-pagination>
    </v-col>
  </v-row>
</template>

<script>
export default {
  props: {
    users: {
      type: Array,
      required: true,
      default: [],
    },
    pagination: {
      type: Object,
      required: true,
      default: {},
    },
  },
  data() {
    return {
      items: [],
    };
  },
  watch: {
    users(newVal, oldVal) {
      this.items = newVal;
    },
  },
  methods: {
    changePage(value) {
      this.$emit("onChangePage", {
        key: "page",
        value,
      });
    },
    onEdit(id) {
      this.$emit("onEdit", id);
    },
    onDelete(id, name) {
      this.$emit("onDelete", { id, name });
    },
    onUpdateStatus(id, name, isActive) {
      this.$emit("onUpdateStatus", { id, name, isActive });
    },
  },
  created() {},
};
</script>
<style scoped></style>
